diff -crN nakedmudv1.5/src/extra_descs.h nakedmudv2.0/src/extra_descs.h
*** nakedmudv1.5/src/extra_descs.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/extra_descs.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 22,37 ****
  //*****************************************************************************
  EDESC_SET  *newEdescSet         ();
  void        deleteEdescSet      (EDESC_SET *set);
! void        copyEdescSetTo      (EDESC_SET *from, EDESC_SET *to);
! EDESC_SET  *copyEdescSet        (EDESC_SET *set);
  void        edescSetPut         (EDESC_SET *set, EDESC_DATA *edesc);
! EDESC_DATA *getEdesc            (EDESC_SET *set, const char *keyword);
! EDESC_DATA *getEdescNum         (EDESC_SET *set, int num);
! EDESC_DATA *removeEdescEntry    (EDESC_SET *set, const char *keyword);
! EDESC_DATA *removeEdescEntryNum (EDESC_SET *set, int num);
  void        removeEdesc         (EDESC_SET *set, EDESC_DATA *edesc);
! int         getEdescSetSize     (EDESC_SET *set);
! LIST       *getEdescList        (EDESC_SET *set);
  char       *tagEdescs           (EDESC_SET *set, const char *string,
  				 const char *start_tag, const char *end_tag);
  
--- 22,37 ----
  //*****************************************************************************
  EDESC_SET  *newEdescSet         ();
  void        deleteEdescSet      (EDESC_SET *set);
! void        edescSetCopyTo      (EDESC_SET *from, EDESC_SET *to);
! EDESC_SET  *edescSetCopy        (EDESC_SET *set);
  void        edescSetPut         (EDESC_SET *set, EDESC_DATA *edesc);
! EDESC_DATA *edescSetGet         (EDESC_SET *set, const char *keyword);
! EDESC_DATA *edescSetGetNum      (EDESC_SET *set, int num);
! EDESC_DATA *edescSetRemove      (EDESC_SET *set, const char *keyword);
! EDESC_DATA *edescSetRemoveNum   (EDESC_SET *set, int num);
  void        removeEdesc         (EDESC_SET *set, EDESC_DATA *edesc);
! int         edescGetSetSize  (EDESC_SET *set);
! LIST       *edescSetGetList     (EDESC_SET *set);
  char       *tagEdescs           (EDESC_SET *set, const char *string,
  				 const char *start_tag, const char *end_tag);
  
***************
*** 57,110 ****
  // make a storage set out of the extra desc set, or parse an extra
  // desc set from the storage set.
  //
! EDESC_SET    *edescSetRead(STORAGE_SET *set);
  STORAGE_SET *edescSetStore(EDESC_SET *edescs);
  
  //
  // Make a copy of the EDESC
  //
! EDESC_DATA *copyEdesc(EDESC_DATA *edesc);
  
  //
  // copy the contents of one EDESC to another
  //
! void copyEdescTo(EDESC_DATA *from, EDESC_DATA *to);
  
  //
  // Get a list of the keywords
  //
! const char *getEdescKeywords(EDESC_DATA *edesc);
  
  //
  // return a pointer to the description
  //
! const char *getEdescDescription(EDESC_DATA *edesc);
  
  //
  // get a pointer to the edesc description (for text editing in OLC)
  //
! char **getEdescPtr(EDESC_DATA *edesc);
  
  //
  // set the keywords to this new list of keywords. Keywords
  // must be comma-separated
  //
! void setEdescKeywords(EDESC_DATA *edesc, const char *keywords);
  
  //
  // set the description to this new description
  //
! void setEdescDescription(EDESC_DATA *edesc, const char *description);
  
  //
  // returns TRUE if the keyword is a valid one
  //
! bool isEdescKeyword(EDESC_DATA *edesc, const char *keyword);
  
  //
  // get the set the edesc belongs to
  //
! EDESC_SET *getEdescSet(EDESC_DATA *edesc);
  
  //
  // For each keyword in our list, tag copies of it in string
--- 57,110 ----
  // make a storage set out of the extra desc set, or parse an extra
  // desc set from the storage set.
  //
! EDESC_SET *edescSetRead(STORAGE_SET *set);
  STORAGE_SET *edescSetStore(EDESC_SET *edescs);
  
  //
  // Make a copy of the EDESC
  //
! EDESC_DATA *edescCopy(EDESC_DATA *edesc);
  
  //
  // copy the contents of one EDESC to another
  //
! void edescCopyTo(EDESC_DATA *from, EDESC_DATA *to);
  
  //
  // Get a list of the keywords
  //
! const char *edescSetGetKeywords(EDESC_DATA *edesc);
  
  //
  // return a pointer to the description
  //
! const char *edescSetGetDesc(EDESC_DATA *edesc);
  
  //
  // get a pointer to the edesc description (for text editing in OLC)
  //
! BUFFER *edescGetDescBuffer(EDESC_DATA *edesc);
  
  //
  // set the keywords to this new list of keywords. Keywords
  // must be comma-separated
  //
! void edescSetKeywords(EDESC_DATA *edesc, const char *keywords);
  
  //
  // set the description to this new description
  //
! void edescSetDesc(EDESC_DATA *edesc, const char *description);
  
  //
  // returns TRUE if the keyword is a valid one
  //
! bool edescIsKeyword(EDESC_DATA *edesc, const char *keyword);
  
  //
  // get the set the edesc belongs to
  //
! EDESC_SET *edescGetSet(EDESC_DATA *edesc);
  
  //
  // For each keyword in our list, tag copies of it in string
diff -crN nakedmudv1.5/src/gameloop.c nakedmudv2.0/src/gameloop.c
*** nakedmudv1.5/src/gameloop.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/gameloop.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 1,11 ****
  //*****************************************************************************
- //
  // gameloop.c
  //
  // contains the entrypoint for the MUD, plus various state-handling functions.
- //
  //*****************************************************************************
- 
  #include "mud.h"
  #include "socket.h"
  #include "world.h"
--- 1,8 ----
***************
*** 15,21 ****
  #include "save.h"
  #include "handler.h"
  #include "inform.h"
- #include "text_editor.h"
  #include "log.h"
  #include "action.h"
  #include "event.h"
--- 12,17 ----
***************
*** 25,58 ****
  #include "body.h"
  
  
  // optional modules
  #ifdef MODULE_TIME
  #include "time/mudtime.h"
  #endif
- #ifdef MODULE_SCRIPTS
- #include "scripts/script.h"
- #endif
- #ifdef MODULE_OLC
- #include "olc/olc.h"
- #endif
- #ifdef MODULE_ALIAS
- #include "alias/alias.h"
- #endif
- #ifdef MODULE_CHAR_VARS
- #include "char_vars/char_vars.h"
- #endif
  #ifdef MODULE_SOCIALS
  #include "socials/socials.h"
  #endif
  #ifdef MODULE_HELP
  #include "help/help.h"
  #endif
! 
! 
! /* mccp support */
! const unsigned char do_echo         [] = { IAC, WONT, TELOPT_ECHO,      '\0' };
! const unsigned char dont_echo       [] = { IAC, WILL, TELOPT_ECHO,      '\0' };
! 
  
  /* local procedures */
  void game_loop    ( int control );
--- 21,54 ----
  #include "body.h"
  
  
+ 
+ //*****************************************************************************
+ // mandatory modules
+ //*****************************************************************************
+ #include "editor/editor.h"
+ #include "char_vars/char_vars.h"
+ #include "items/items.h"
+ #include "olc2/olc.h"
+ #include "set_val/set_val.h"
+ #include "scripts/script.h"
+ 
+ 
+ 
+ //*****************************************************************************
  // optional modules
+ //*****************************************************************************
  #ifdef MODULE_TIME
  #include "time/mudtime.h"
  #endif
  #ifdef MODULE_SOCIALS
  #include "socials/socials.h"
  #endif
  #ifdef MODULE_HELP
  #include "help/help.h"
  #endif
! #ifdef MODULE_ALIAS
! #include "alias/alias.h"
! #endif
  
  /* local procedures */
  void game_loop    ( int control );
***************
*** 69,76 ****
  WORLD_DATA *gameworld = NULL;   /*  the gameworld, and ll the prototypes */
  LIST * object_list = NULL;      /*  the list of all existing objects */
  LIST * socket_list = NULL;      /*  the list of active sockets */
- LIST * socket_free = NULL;      /*  the list of free sockets */
  LIST * mobile_list = NULL;      /*  the list of existing mobiles */
  PROPERTY_TABLE *mob_table = NULL;/* a table of mobs by UID, for quick lookup */
  PROPERTY_TABLE *obj_table = NULL;
  
--- 65,73 ----
  WORLD_DATA *gameworld = NULL;   /*  the gameworld, and ll the prototypes */
  LIST * object_list = NULL;      /*  the list of all existing objects */
  LIST * socket_list = NULL;      /*  the list of active sockets */
  LIST * mobile_list = NULL;      /*  the list of existing mobiles */
+ LIST * extract_obj_funcs = NULL;/*  functions called when an obj is extracted */
+ LIST * extract_mob_funcs = NULL;/*  functions called when a char is extracted */
  PROPERTY_TABLE *mob_table = NULL;/* a table of mobs by UID, for quick lookup */
  PROPERTY_TABLE *obj_table = NULL;
  
***************
*** 83,88 ****
--- 80,86 ----
   */
  int main(int argc, char **argv)
  {
+   extern fd_set fSet;
    int i;
    bool fCopyOver = FALSE;
  
***************
*** 112,142 ****
      return 1;
    }
  
  
  
    /************************************************************/
!   /*               INITIALIZE WHAT WE NEED TO                 */
    /************************************************************/
  
!   /* create our global lists */
    object_list = newList();
    socket_list = newList();
-   socket_free = newList();
    mobile_list = newList();
!   // if you've got more than 12000 or so mobs in your
!   // game at a time, you may want to increase this 
!   // value by a bit
    mob_table   = newPropertyTable(charGetUID, 3000);
    obj_table   = newPropertyTable(objGetUID,  3000);
  
!   /* note that we are booting up */
!   log_string("Program starting.");
  
-   /* seed the random number generator */
-   srand(time(0));
  
!   /* get the current time */
!   current_time = time(NULL);
  
    /* initialize our mud settings, such as top character id */
    log_string("Initializing MUD settings.");
--- 110,153 ----
      return 1;
    }
  
+   /* seed the random number generator */
+   srand(time(0));
+ 
+   /* get the current time */
+   current_time = time(NULL);
+ 
+   // change to the lib directory
+   //log_string("Changing to lib directory.");
+   //chdir("../lib");
  
  
    /************************************************************/
!   /*           INITIALIZE ALL OUR LISTS AND TABLES            */
    /************************************************************/
  
!   // lists for storing objects, sockets, and mobiles that are
!   // currently loaded into the game
    object_list = newList();
    socket_list = newList();
    mobile_list = newList();
! 
!   // tables for quick lookup of mobiles and objects by UID.
!   // For optimal speed, the table sizes should be roughly
!   // 25% larger than the number of mobs/objs you intend to have
!   // loaded into the game at any given time.
    mob_table   = newPropertyTable(charGetUID, 3000);
    obj_table   = newPropertyTable(objGetUID,  3000);
  
!   // functions that should be called when objs/mobs 
!   // are extracted from the game world
!   extract_obj_funcs = newList();
!   extract_mob_funcs = newList();
  
  
! 
!   /************************************************************/
!   /*        INITIALIZE OUR SETTINGS AND BASIC SYSTEMS         */
!   /************************************************************/
  
    /* initialize our mud settings, such as top character id */
    log_string("Initializing MUD settings.");
***************
*** 146,198 ****
    log_string("Preparing auxiliary data for usage.");
    init_auxiliaries();
  
!   /* prepare races and bodies for use */
    log_string("Initializing races and default bodies.");
    init_races();
  
-   /* initialize our command table */
    log_string("Initializing command table.");
    init_commands();
  
-   /* initialize actions */
    log_string("Initializing action handler.");
    init_actions();
  
-   /* initialize events */
    log_string("Initializing event handler.");
    init_events();
  
!   // change to the lib directory
!   //log_string("Changing to lib directory.");
!   //chdir("../lib");
  
- #ifdef MODULE_SCRIPTS
-   /* initialize the scripting language */
-   log_string("Initializing scripts.");
-   init_scripts();
- #endif
  
- #ifdef MODULE_OLC
-   /* initialize online creation */
-   log_string("Initializing OLC.");
-   init_olc();
- #endif
  
! #ifdef MODULE_TIME
!   log_string("Initializing game time.");
!   init_time();
! #endif
  
- #ifdef MODULE_CHAR_VARS
    log_string("Initializing character variables.");
    init_char_vars();
- #endif
  
  #ifdef MODULE_ALIAS
    log_string("Initializing aliases.");
    init_aliases();
  #endif
  
  #ifdef MODULE_SOCIALS
    log_string("Initializing socials.");
    init_socials();
--- 157,219 ----
    log_string("Preparing auxiliary data for usage.");
    init_auxiliaries();
  
!   log_string("Initializing bitvectors.");
!   init_bitvectors();
! 
    log_string("Initializing races and default bodies.");
    init_races();
  
    log_string("Initializing command table.");
    init_commands();
  
    log_string("Initializing action handler.");
    init_actions();
  
    log_string("Initializing event handler.");
    init_events();
  
!   log_string("Initializing logging system.");
!   init_logs();
  
  
  
!   /**********************************************************************/
!   /*                START MANDATORY MODULE INSTALLATION                 */
!   /**********************************************************************/
!   log_string("Initializing item types.");
!   init_items();
! 
!   log_string("Initializing editor.");
!   init_editor();
!   init_notepad();
  
    log_string("Initializing character variables.");
    init_char_vars();
  
+   log_string("Initializing OLC v2.0.");
+   init_olc2();
+ 
+   log_string("Initializing set utility.");
+   init_set();
+ 
+   log_string("Initializing scripts.");
+   init_scripts();
+ 
+ 
+   
+   /**********************************************************************/
+   /*                 START OPTIONAL MODULE INSTALLATION                 */
+   /**********************************************************************/
  #ifdef MODULE_ALIAS
    log_string("Initializing aliases.");
    init_aliases();
  #endif
  
+ #ifdef MODULE_TIME
+   log_string("Initializing game time.");
+   init_time();
+ #endif
+ 
  #ifdef MODULE_SOCIALS
    log_string("Initializing socials.");
    init_socials();
***************
*** 203,234 ****
    init_help();
  #endif
  
    /* initialize the socket */
    if (!fCopyOver) {
      log_string("Initializing sockets.");
      control = init_socket();
    }
  
!   /* load all of the logs */
!   log_string("Initializing logging system.");
!   init_logs();
  
!   /* load all external data */
!   log_string("Logging world and reconnecting copyover sockets.");
!   load_muddata(fCopyOver);
  
-   // force-pulse everything once
-   log_string("Force-resetting world");
-   worldForceReset(gameworld);
  
    // main game loop
    log_string("Entering game loop");
    game_loop(control);
  
- #ifdef MODULE_SCRIPTS
    // stop the scripts
    finalize_scripts();
- #endif
  
    // close down the socket
    close(control);
--- 224,273 ----
    init_help();
  #endif
  
+ 
+ 
+ 
+   /**********************************************************************/
+   /*                          SPAWN THE WORLD                           */
+   /**********************************************************************/
+   /* load all game data */
+   log_string("Loading gameworld.");
+   load_muddata();
+ 
+   // force-pulse everything once
+   log_string("Force-resetting world");
+   worldForceReset(gameworld);
+ 
+ 
+   /**********************************************************************/
+   /*                  HANDLE THE SOCKET STARTUP STUFF                   */
+   /**********************************************************************/
    /* initialize the socket */
    if (!fCopyOver) {
      log_string("Initializing sockets.");
      control = init_socket();
    }
  
!   /* clear out the file socket set */
!   FD_ZERO(&fSet);
  
!   /* add control to the set */
!   FD_SET(control, &fSet);
! 
!   // attach our old sockets
!   if(fCopyOver)
!     copyover_recover();
  
  
+   /**********************************************************************/
+   /*             START THE GAME UP, AND HANDLE ITS SHUTDOWN             */
+   /**********************************************************************/
    // main game loop
    log_string("Entering game loop");
    game_loop(control);
  
    // stop the scripts
    finalize_scripts();
  
    // close down the socket
    close(control);
***************
*** 266,293 ****
  
  void game_loop(int control)   
  {
-   SOCKET_DATA *dsock;
    static struct timeval tv;
    struct timeval last_time, new_time;
    extern fd_set fSet;
!   fd_set rFd;
    long secs, usecs;
-   LIST_ITERATOR *sock_i = newListIterator(socket_list);
  
    /* set this for the first loop */
    gettimeofday(&last_time, NULL);
  
-   /* clear out the file socket set */
-   FD_ZERO(&fSet);
- 
-   /* add control to the set */
-   FD_SET(control, &fSet);
- 
-   /* copyover recovery */
-   ITERATE_LIST(dsock, sock_i)
-     FD_SET(dsock->control, &fSet);
-   deleteListIterator(sock_i);
- 
    /* do this untill the program is shutdown */
    while (!shut_down)
    {
--- 305,319 ----
  
  void game_loop(int control)   
  {
    static struct timeval tv;
    struct timeval last_time, new_time;
    extern fd_set fSet;
!   extern fd_set rFd;
    long secs, usecs;
  
    /* set this for the first loop */
    gettimeofday(&last_time, NULL);
  
    /* do this untill the program is shutdown */
    while (!shut_down)
    {
***************
*** 302,309 ****
        continue;
  
      /* check for new connections */
!     if (FD_ISSET(control, &rFd))
!     {
        struct sockaddr_in sock;
        unsigned int socksize;
        int newConnection;
--- 328,334 ----
        continue;
  
      /* check for new connections */
!     if (FD_ISSET(control, &rFd)) {
        struct sockaddr_in sock;
        unsigned int socksize;
        int newConnection;
***************
*** 313,380 ****
          new_socket(newConnection);
      }
  
-     /* poll sockets in the socket list */
-     //    listIteratorReset(sock_i);
-     sock_i = newListIterator(socket_list);
- 
-     ITERATE_LIST(dsock, sock_i) {
-       /*
-        * Close sockects we are unable to read from.
-        */
-       if (FD_ISSET(dsock->control, &rFd) && !read_from_socket(dsock)) {
-         close_socket(dsock, FALSE);
-         continue;
-       }
- 
-       /* Ok, check for a new command */
-       next_cmd_from_buffer(dsock);
  
!       /* Is there a new command pending ? */
!       // I switched to a true/false variable instead of checking if the
!       // first char was \0 so that people in OLC and in scripts can easily
!       // put newlines down when they need to.
!       if (dsock->cmd_read)
!       {
!         /* figure out how to deal with the incoming command */
!         switch(dsock->state)
!         {
! 	default:
! 	  bug("Descriptor in bad state.");
! 	  break;
! 	case STATE_NEW_NAME:
! 	case STATE_NEW_PASSWORD:
! 	case STATE_VERIFY_PASSWORD:
! 	case STATE_ASK_PASSWORD:
! 	case STATE_ASK_SEX:
!    	case STATE_ASK_RACE:
! 	  handle_new_connections(dsock, dsock->next_command);
! 	  break;
! 	case STATE_PLAYING:
! 	  handle_cmd_input(dsock, dsock->next_command);
! 	  break;
! #ifdef MODULE_OLC
! 	case STATE_OLC:
! 	  olc_loop(dsock, dsock->next_command);
! 	  break;
! #endif
! 	case STATE_TEXT_EDITOR:
! 	  text_editor_loop(dsock, dsock->next_command);
! 	  break;
!         }
!         dsock->next_command[0] = '\0';
! 	dsock->cmd_read = FALSE;
!       }
! 
!       /* if the player quits or get's disconnected */
!       if (dsock->state == STATE_CLOSED) continue;
! 
!       /* Send all new data to the socket and close it if any errors occour */
!       if (!flush_output(dsock))
!         close_socket(dsock, FALSE);
!     }
!     deleteListIterator(sock_i);
  
!     /* call the top-level update handler */
      update_handler();
  
      /*
--- 338,348 ----
          new_socket(newConnection);
      }
  
  
!     /* check all of the sockets for input */
!     socket_handler();
  
!     /* call the top-level update handler for events and actions */
      update_handler();
  
      /*
***************
*** 413,431 ****
          continue;
      }
  
-     /* wait out the rest of the pulse */
-     /*
-     while(TRUE) {
-       gettimeofday(&new_time, NULL);
-       secs  = (int) (new_time.tv_sec - last_time.tv_sec);
-       usecs = (int) (new_time.tv_usec - last_time.tv_usec);
- 
-       // check to see if we've gone over time time that is in PULSES_PER_SECOND
-       if(secs * 1000000 + usecs >= 1000000 / PULSES_PER_SECOND)
- 	break;
-     }
-     */
- 
      /* reset the last time we where sleeping */
      gettimeofday(&last_time, NULL);
  
--- 381,386 ----
***************
*** 433,741 ****
      recycle_sockets();
    }
  }
- 
- 
- 
- //*****************************************************************************
- //
- // STATE HANDLER AND RELATED FUNCTIONS
- //
- // Below this point are functions to do with handling a socket's state
- // (e.g. get new name, password, character creation stuff, etc...)
- //
- //*****************************************************************************
- 
- //
- // Ask a new connection for a name. This is the first thing that is called
- // whenever a new socket connects to us
- //
- void state_new_name(SOCKET_DATA *dsock, char *arg) {
-   CHAR_DATA *p_new;
- 
-   if (dsock->lookup_status != TSTATE_DONE) {
-     text_to_buffer(dsock, 
- 		   "Making a dns lookup, please have patience.\n\r"
- 		   "What is your name? ");
-     return;
-   }
-   if (!check_name(arg)) /* check for a legal name */ {
-     text_to_buffer(dsock, 
- 		   "Sorry, that's not a legal name, please pick another.\n\r"
- 		   "What is your name? ");
-     return;//    break;
-   }
-   arg[0] = toupper(arg[0]);
-   log_string("%s is trying to connect.", arg);
- 
- 
-   /* Check for a new Player */
-   if ((p_new = load_profile(arg)) == NULL) {
-     p_new = newChar();
- 
-     /* give the player it's name */
-     charSetName(p_new, arg);
- 
-     /* and room description. In the future, we may want
-        to consider allowing players to seet their own rdescs */
-     char rdesc[SMALL_BUFFER];
-     sprintf(rdesc, "%s is here.", arg);
-     charSetRdesc(p_new, rdesc);
- 
-     /* prepare for next step */
-     text_to_buffer(dsock, "Please enter a new password: ");
-     dsock->state = STATE_NEW_PASSWORD;
-   }
-   else /* old player */ {
-     /* prepare for next step */
-     text_to_buffer(dsock, "What is your password? ");
-     dsock->state = STATE_ASK_PASSWORD;
-   }
-   text_to_buffer(dsock, (char *) dont_echo);
- 
-   /* socket <-> player */
-   charSetSocket(p_new, dsock);
-   dsock->player = p_new;
- }
- 
- 
- //
- // Ask a character for a password. This is only called once, when
- // the character first creates.
- //
- void state_new_password(SOCKET_DATA *dsock, char *arg) {
-   int i;
- 
-   if (strlen(arg) < 5 || strlen(arg) > 12) {
-     text_to_buffer(dsock, 
- 		   "\r\nBetween 5 and 12 chars please!\n\r"
- 		   "Please enter a new password: ");
-     return;
-   }
-   charSetPassword(dsock->player, crypt(arg, charGetName(dsock->player)));
- 
-   for (i = 0; i < strlen(charGetPassword(dsock->player)); i++) {
-     if (charGetPassword(dsock->player)[i] == '~') {
-       text_to_buffer(dsock,
- 		     "Illegal password!\n\r"
- 		     "Please enter a new password: ");
-       return;
-     }
-   }
- 
-   text_to_buffer(dsock, "\r\nPlease verify the password: ");
-   dsock->state = STATE_VERIFY_PASSWORD;
- }
- 
- 
- //
- // Verify that the character's new password is correct. This is
- // only called once, when the character creates
- //
- void state_verify_password(SOCKET_DATA *dsock, char *arg) {
-   if (compares(crypt(arg, charGetName(dsock->player)), 
- 	       charGetPassword(dsock->player))) {
-     text_to_buffer(dsock, (char *) do_echo);
- 
-     /* onto the sex check */
-     dsock->state = STATE_ASK_SEX;
-     text_to_buffer(dsock, "\r\nWhat is your sex (M/F/N): ");
-   }
-   else {
-     charSetPassword(dsock->player, NULL);
-     text_to_buffer(dsock, 
- 		   "\r\nPassword mismatch!\n\r"
- 		   "Please enter a new password: ");
-     dsock->state = STATE_NEW_PASSWORD;
-   }
- }
- 
- void list_races(SOCKET_DATA *sock) {
-   send_to_socket(sock, "Available races are:\r\n");
-   send_to_socket(sock, "%s", raceGetList(TRUE));
-   send_to_socket(sock, "\r\n\r\nPlease enter your choice: ");
- }
- 
- //
- // Ask for the character's race. Called each time a character is created
- //
- void state_ask_race(SOCKET_DATA *dsock, char *arg) {
-   if(!arg || !*arg || !raceIsForPC(arg)) {
-     send_to_socket(dsock, "Invalid race! Please try again: ");
-     return;
-   }    
-   else {
-     charSetRace(dsock->player, arg);
-     charResetBody(dsock->player);
-   }
- 
-   /* give the character a unique id */
-   charSetUID(dsock->player, next_char_uid());
- 
-   /* if it's the first player, set him as the highest level */
-   if(charGetUID(dsock->player) == 1)
-     charSetLevel(dsock->player, MAX_LEVEL);
- 
-   /* add the character to the game */
-   char_to_game(dsock->player);
- 
-   log_string("New player: %s has entered the game.", 
- 	     charGetName(dsock->player));
-     
-   /* and into the game */
-   dsock->state = STATE_PLAYING;
-   text_to_buffer(dsock, motd);
- 
-   // we should do some checks here to make sure the start room exists
-   char_to_room(dsock->player, worldGetRoom(gameworld, START_ROOM));
-   look_at_room(dsock->player, charGetRoom(dsock->player));
- 
-   /* and save him */
-   save_player(dsock->player);
- 
- #ifdef MODULE_SCRIPTS
-   // check enterance scripts
-   try_enterance_script(dsock->player, charGetRoom(dsock->player), NULL);
- #endif
- }
- 
- //
- // Ask for the character's sex. This will be called each time the
- // character creates
- //
- void state_ask_sex(SOCKET_DATA *dsock, char *arg) {
-   switch(*arg) {
-   case 'f':
-   case 'F':
-     charSetSex(dsock->player, SEX_FEMALE);
-     break;
-   case 'm':
-   case 'M':
-     charSetSex(dsock->player, SEX_MALE);
-     break;
-   case 'n':
-   case 'N':
-     charSetSex(dsock->player, SEX_NEUTRAL);
-     break;
-   default:
-     text_to_buffer(dsock, "\r\nInvalid sex. Try again (M/F/N) :");
-     return;
-   }
- 
-   /* onto the password check */
-   dsock->state = STATE_ASK_RACE;
-   list_races(dsock);
- }
- 
- 
- //
- // Ask the character for his or her password. This will be called
- // every time the character logs on, after the first time when the
- // character creates
- //
- void state_ask_password(SOCKET_DATA *dsock, char *arg) {
-   CHAR_DATA *p_new;
- 
-   text_to_buffer(dsock, (char *) do_echo);
-   if (compares(crypt(arg, charGetName(dsock->player)), 
- 	       charGetPassword(dsock->player)))
-   {
-     if ((p_new = check_reconnect(charGetName(dsock->player))) != NULL) {
-       // we do NOT want to extract, here... the player hasn't even
-       // entered the game yet. We just want to DELETE the profile character
-       deleteChar(dsock->player);
- 
-       /* attach the new player */
-       dsock->player = p_new;
-       charSetSocket(p_new, dsock);
- 
-       log_string("%s has reconnected.", charGetName(dsock->player));
- 
-       /* and let him enter the game */
-       dsock->state = STATE_PLAYING;
-       text_to_buffer(dsock, "You take over a body already in use.\n\r");
-     }
-     else if ((p_new = load_player(charGetName(dsock->player))) == NULL) {
-       text_to_socket(dsock, "ERROR: Your pfile is missing!\n\r");
-       // no extract, just delete! We haven't entered the game yet,
-       // so there is no need to extract
-       deleteChar(dsock->player);
- 
-       dsock->player = NULL;
-       close_socket(dsock, FALSE);
-       return;
-     }
-     else {
-       // No extract, just delete. We have not entered the game yet,
-       // so there is no need to extract from it.
-       deleteChar(dsock->player);
- 
-       /* attach the new player */
-       dsock->player = p_new;
-       charSetSocket(p_new, dsock);
- 
-       // try putting the character into the game.
-       // Close the socket if we fail
-       if(try_enter_game(p_new)) {
- 	log_string("%s has entered the game.", charGetName(p_new));
- 	dsock->state = STATE_PLAYING;
- 	text_to_buffer(dsock, motd);
- 	look_at_room(p_new, charGetRoom(p_new));
- 
- #ifdef MODULE_SCRIPTS
- 	// check enterance scripts
- 	try_enterance_script(p_new, charGetRoom(p_new), NULL);
- #endif
-       }
-       else {
- 	// do not extract, just delete. We failed to enter
- 	// the game, so there is no need to extract from the game.
- 	deleteChar(dsock->player);
- 
- 	dsock->player = NULL;
- 	close_socket(dsock, FALSE);
-       }
-     }
-   }
-   else {
-     text_to_socket(dsock, "Bad password!\n\r");
-     // do not extract, just delete. We have not entered the game
-     // yet, so there is no need to extract from the game.
-     deleteChar(dsock->player);
- 
-     dsock->player = NULL;
-     close_socket(dsock, FALSE);
-   }
- }
- 
- 
- void handle_new_connections(SOCKET_DATA *dsock, char *arg) {
-   switch(dsock->state) {
-   case STATE_NEW_NAME:
-     state_new_name(dsock, arg);
-     break;
- 
-   case STATE_NEW_PASSWORD:
-     state_new_password(dsock, arg);
-     break;
-     
-   case STATE_VERIFY_PASSWORD:
-     state_verify_password(dsock, arg);
-     break;
-     
-   case STATE_ASK_PASSWORD:
-     state_ask_password(dsock, arg);
-     break;
- 
-   case STATE_ASK_SEX:
-     state_ask_sex(dsock, arg);
-     break;
- 
-   case STATE_ASK_RACE:
-     state_ask_race(dsock, arg);
-     break;
- 
-   default:
-     bug("Handle_new_connections: Bad state.");
-     break;
-   }
- }
--- 388,390 ----
diff -crN nakedmudv1.5/src/gameloop.d nakedmudv2.0/src/gameloop.d
*** nakedmudv1.5/src/gameloop.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/gameloop.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,7 ----
+ gameloop.d gameloop.o: gameloop.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h socket.h world.h character.h \
+   object.h utils.h save.h handler.h inform.h log.h action.h event.h \
+   auxiliary.h storage.h races.h body.h editor/editor.h \
+   char_vars/char_vars.h items/items.h olc2/olc.h set_val/set_val.h \
+   scripts/script.h time/mudtime.h socials/socials.h help/help.h \
+   alias/alias.h
